/*************************************************************
 * By: Coralys Cubero Rivera
 * Date: 2019
 *************************************************************/

package uprrp.tania;

import android.os.AsyncTask;
import android.util.Log;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;

public class SendConsentForm extends AsyncTask <String, String, String> {
    @Override
    protected String doInBackground(String... strings) {
        String jsonConsentSignature  = "";

        try {
            jsonConsentSignature = URLEncoder.encode("data", "UTF-8") + "=" + URLEncoder.encode(strings[0], "UTF-8");
        }

        catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        String serverReply = "";
        BufferedReader serverReader;

        //Send the signature to MARLE's server
        try
        {
            //Defined URL  where to send data
            URL url = new URL("https://tania.uprrp.edu/getSignatureIOS.php");

            //Send POST data request
            URLConnection conn = url.openConnection();
            conn.setDoOutput(true);

            Writer writer = new BufferedWriter(new OutputStreamWriter(conn.getOutputStream(), StandardCharsets.UTF_8));
            writer.write(jsonConsentSignature);
            writer.close();

            InputStream inputStream = conn.getInputStream();
            if (inputStream == null) {
                return null;
            }

            //Get the server response
            serverReader = new BufferedReader(new InputStreamReader(inputStream));
            StringBuilder serverResponse = new StringBuilder();
            String serverResponseLine;

            // Read Server Response
            while((serverResponseLine = serverReader.readLine()) != null)
            {
                //Append server response in string
                serverResponse.append(serverResponseLine);
            }

            serverReply = serverResponse.toString();
        }
        catch(Exception ex) {
            Log.e("ERROR CONSENT SIGNATURE", ex.getMessage());
        }

        return serverReply;
    }

    @Override
    protected void onPostExecute(String s) {
        Log.d("CONSENT SERVER REPLY", s);

    }

}
